<!-- BEGIN_TF_DOCS -->
## Requirements

| Name | Version |
|------|---------|
| <a name="requirement_terraform"></a> [terraform](#requirement\_terraform) | ~> 1.5 |
| <a name="requirement_gitlab"></a> [gitlab](#requirement\_gitlab) | 16.9.1 |

## Providers

| Name | Version |
|------|---------|
| <a name="provider_gitlab"></a> [gitlab](#provider\_gitlab) | 16.9.1 |

## Modules

No modules.

## Resources

| Name | Type |
|------|------|
| [gitlab_branch_protection.this](https://registry.terraform.io/providers/gitlabhq/gitlab/16.9.1/docs/resources/branch_protection) | resource |
| [gitlab_pipeline_schedule.schedule](https://registry.terraform.io/providers/gitlabhq/gitlab/16.9.1/docs/resources/pipeline_schedule) | resource |
| [gitlab_pipeline_schedule_variable.variable](https://registry.terraform.io/providers/gitlabhq/gitlab/16.9.1/docs/resources/pipeline_schedule_variable) | resource |
| [gitlab_project.this](https://registry.terraform.io/providers/gitlabhq/gitlab/16.9.1/docs/resources/project) | resource |
| [gitlab_project_approval_rule.this](https://registry.terraform.io/providers/gitlabhq/gitlab/16.9.1/docs/resources/project_approval_rule) | resource |
| [gitlab_project_level_mr_approvals.this](https://registry.terraform.io/providers/gitlabhq/gitlab/16.9.1/docs/resources/project_level_mr_approvals) | resource |
| [gitlab_project_variable.variable](https://registry.terraform.io/providers/gitlabhq/gitlab/16.9.1/docs/resources/project_variable) | resource |

## Inputs

| Name | Description | Type | Default | Required |
|------|-------------|------|---------|:--------:|
| <a name="input_approval_rule_group_ids"></a> [approval\_rule\_group\_ids](#input\_approval\_rule\_group\_ids) | List of group ids for approval rule | `list(number)` | `[]` | no |
| <a name="input_namespace_id"></a> [namespace\_id](#input\_namespace\_id) | Namespace id | `number` | n/a | yes |
| <a name="input_projects"></a> [projects](#input\_projects) | Map for list of projects | <pre>map(object({<br>    allow_merge_on_skipped_pipeline                  = optional(bool, false)<br>    analytics_access_level                           = optional(string, "enabled")<br>    approvals_before_merge                           = optional(number, 0)<br>    archived                                         = optional(bool, false)<br>    auto_cancel_pending_pipelines                    = optional(string, "enabled")<br>    auto_devops_deploy_strategy                      = optional(string, null)<br>    auto_devops_enabled                              = optional(bool, false)<br>    autoclose_referenced_issues                      = optional(bool, true)<br>    avatar                                           = optional(string, null)<br>    build_git_strategy                               = optional(string, "fetch")<br>    build_timeout                                    = optional(number, 3600)<br>    builds_access_level                              = optional(string, "enabled")<br>    ci_config_path                                   = optional(string, null)<br>    ci_default_git_depth                             = optional(number, 20)<br>    ci_forward_deployment_enabled                    = optional(bool, true)<br>    ci_restrict_pipeline_cancellation_role           = optional(string, "developer")<br>    ci_separated_caches                              = optional(bool, true)<br>    container_registry_access_level                  = optional(string, "disabled")<br>    default_branch                                   = optional(string, "master")<br>    description                                      = optional(string, null)<br>    emails_disabled                                  = optional(bool, false)<br>    environments_access_level                        = optional(string, "disabled")<br>    external_authorization_classification_label      = optional(string, null)<br>    feature_flags_access_level                       = optional(string, "disabled")<br>    forked_from_project_id                           = optional(number, null)<br>    group_runners_enabled                            = optional(bool, true)<br>    infrastructure_access_level                      = optional(string, "disabled")<br>    initialize_with_readme                           = optional(bool, false)<br>    issues_access_level                              = optional(string, "disabled")<br>    issues_enabled                                   = optional(bool, false)<br>    issues_template                                  = optional(string, null)<br>    keep_latest_artifact                             = optional(bool, true)<br>    lfs_enabled                                      = optional(bool, true)<br>    merge_commit_template                            = optional(string, null)<br>    merge_method                                     = optional(string, "merge")<br>    merge_pipelines_enabled                          = optional(bool, false)<br>    merge_requests_access_level                      = optional(string, "enabled")<br>    merge_requests_enabled                           = optional(bool, true)<br>    merge_requests_template                          = optional(string, null)<br>    merge_trains_enabled                             = optional(bool, false)<br>    monitor_access_level                             = optional(string, "enabled")<br>    only_allow_merge_if_all_discussions_are_resolved = optional(bool, true)<br>    only_allow_merge_if_pipeline_succeeds            = optional(bool, true)<br>    packages_enabled                                 = optional(bool, false)<br>    pages_access_level                               = optional(string, "disabled")<br>    path                                             = optional(string, null)<br>    printing_merge_request_link_enabled              = optional(bool, true)<br>    releases_access_level                            = optional(string, "enabled")<br>    remove_source_branch_after_merge                 = optional(bool, true)<br>    repository_access_level                          = optional(string, "enabled")<br>    repository_storage                               = optional(string, null)<br>    request_access_enabled                           = optional(bool, false)<br>    requirements_access_level                        = optional(string, "disabled")<br>    resolve_outdated_diff_discussions                = optional(bool, true)<br>    restrict_user_defined_variables                  = optional(bool, false)<br>    security_and_compliance_access_level             = optional(string, "private")<br>    shared_runners_enabled                           = optional(bool, false)<br>    snippets_access_level                            = optional(string, "enabled")<br>    snippets_enabled                                 = optional(bool, true)<br>    squash_commit_template                           = optional(string, null)<br>    squash_option                                    = optional(string, "default_off")<br>    suggestion_commit_message                        = optional(string, null)<br>    tags                                             = optional(list(string), [])<br>    visibility_level                                 = optional(string, "private")<br>    wiki_access_level                                = optional(string, "disabled")<br>    wiki_enabled                                     = optional(bool, false)<br>    push_rules = object({<br>      author_email_regex            = optional(string, null)<br>      branch_name_regex             = optional(string, "(renovate|feature|feat|fix|hotfix|chore|breaking-change|ci|docs|style|refactor|perf|test|release|revert)\\/*")<br>      commit_committer_check        = optional(bool, false)<br>      commit_message_negative_regex = optional(string, "")<br>      commit_message_regex          = optional(string, null)<br>      deny_delete_tag               = optional(bool, false)<br>      file_name_regex               = optional(string, null)<br>      max_file_size                 = optional(number, 0)<br>      member_check                  = optional(bool, true)<br>      prevent_secrets               = optional(bool, true)<br>      reject_unsigned_commits       = optional(bool, false)<br>    })<br>    branch_protection = object({<br>      enabled                      = optional(bool, true)<br>      allow_force_push             = optional(bool, false)<br>      push_access_level            = optional(string, "no one")<br>      merge_access_level           = optional(string, "developer")<br>      code_owner_approval_required = optional(bool, true)<br>      users_allowed_to_push        = optional(list(number), [])<br>    })<br>    approval_rule = object({<br>      enabled            = optional(bool, true)<br>      name               = optional(string, "Review rule")<br>      approvals_required = optional(number, 1)<br>    })<br>    level_mr_approvals = object({<br>      enabled                                        = optional(bool, true)<br>      reset_approvals_on_push                        = optional(bool, false)<br>      disable_overriding_approvers_per_merge_request = optional(bool, false)<br>      merge_requests_author_approval                 = optional(bool, false)<br>      merge_requests_disable_committers_approval     = optional(bool, false)<br>    })<br>    variables = optional(map(object({<br>      value             = string<br>      protected         = optional(bool, false)<br>      masked            = optional(bool, false)<br>      environment_scope = optional(string, "*")<br>      variable_type     = optional(string, "env_var")<br>    })), {})<br>    schedules = optional(map(object({<br>      ref           = string<br>      cron          = string<br>      active        = bool<br>      cron_timezone = optional(string, "Europe/Paris")<br>      variables = optional(map(object({<br>        value         = string<br>      })), {})<br>    })), {})<br>  }))</pre> | n/a | yes |

## Outputs

| Name | Description |
|------|-------------|
| <a name="output_projects"></a> [projects](#output\_projects) | List of created projects with module |
<!-- END_TF_DOCS -->